Overview | Package | Class | Deprecated | Index | Help
| Groovy 1.7.0
| FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.codehaus.groovy.control
Class CompilerConfiguration

    java.lang.Object
      org.codehaus.groovy.control.CompilerConfiguration

    class CompilerConfiguration
    extends Object

Compilation control flags and coordination stuff.

author:
  Chris Poirier

author:
  Jochen Theodorou

author:
  Jim White

version:
  $Id: CompilerConfiguration.java 16623 2009-06-02 00:59:26Z paulk $

Field Summary
`static CompilerConfiguration` | `DEFAULT` A convenience for getting a default configuration.
`static String` | `POST_JDK5` This (`"1.5"`) is the value for targetBytecode to compile for a JDK 1.5 or later JVM
`static String` | `PRE_JDK5` This (`"1.4"``) is the value for targetBytecode to compile for a JDK 1.4 JVM`
`static String` | `currentJVMVersion`

Constructor Summary
`CompilerConfiguration()` Sets the Flags to defaults.
`CompilerConfiguration(CompilerConfiguration configuration)` Copy constructor.
`CompilerConfiguration(Properties configuration)` Sets the Flags to the specified configuration, with defaults for those not supplied.

Method Summary
`void` | `configure(Properties configuration)` Method to configure a this CompilerConfiguration by using Properties.
`List` | `getClasspath()`
`boolean` | `getDebug()` Returns true if debugging operation has been requested.
`String` | `getDefaultScriptExtension()`
`Map` | `getJointCompilationOptions()` Gets the joint compilation options for this configuration.
`int` | `getMinimumRecompilationInterval()`
`PrintWriter` | `getOutput()` Gets the currently configured output writer.
`ParserPluginFactory` | `getPluginFactory()`
`boolean` | `getRecompileGroovySource()`
`String` | `getScriptBaseClass()` Gets the name of the base class for scripts.
`String` | `getSourceEncoding()` Gets the currently configured source file encoding.
`String` | `getTargetBytecode()` Retrieves the compiler bytecode compatibility mode.
`File` | `getTargetDirectory()` Gets the target directory for writing classes.
`int` | `getTolerance()` Returns the requested error tolerance.
`boolean` | `getVerbose()` Returns true if verbose operation has been requested.
`int` | `getWarningLevel()` Gets the currently configured warning level.
`void` | `setClasspath(String classpath)` Sets the classpath.
`void` | `setClasspathList(List l)` sets the classpath using a list of Strings
`void` | `setDebug(boolean debug)` Turns debugging operation on or off.
`void` | `setDefaultScriptExtension(String defaultScriptExtension)`
`void` | `setJointCompilationOptions(Map options)` Sets the joint compilation options for this configuration.
`void` | `setMinimumRecompilationInterval(int time)`
`void` | `setOutput(PrintWriter output)` Sets the output writer.
`void` | `setPluginFactory(ParserPluginFactory pluginFactory)`
`void` | `setRecompileGroovySource(boolean recompile)`
`void` | `setScriptBaseClass(String scriptBaseClass)` Sets the name of the base class for scripts.
`void` | `setSourceEncoding(String encoding)` Sets the encoding to be used when reading source files.
`void` | `setTargetBytecode(String version)` Allow setting the bytecode compatibility.
`void` | `setTargetDirectory(String directory)` Sets the target directory.
`void` | `setTargetDirectory(File directory)` Sets the target directory.
`void` | `setTolerance(int tolerance)` Sets the error tolerance, which is the number of non-fatal errors (per unit) that should be tolerated before compilation is aborted.
`void` | `setVerbose(boolean verbose)` Turns verbose operation on or off.
`void` | `setWarningLevel(int level)` Sets the warning level.

Methods inherited from class Object
wait, wait, wait, hashCode, getClass, equals, toString, notify, notifyAll

Field Detail

### DEFAULT

    static final CompilerConfiguration DEFAULT

  A convenience for getting a default configuration. Do not modify it! See #CompilerConfiguration(Properties) for an example on how to make a suitable copy to modify. But if you're really starting from a default context, then you probably just want `new CompilerConfiguration()`.

### POST_JDK5

    static final String POST_JDK5

  This (`"1.5"`) is the value for targetBytecode to compile for a JDK 1.5 or later JVM. *

### PRE_JDK5

    static final String PRE_JDK5

  This (`"1.4"``) is the value for targetBytecode to compile for a JDK 1.4 JVM. *`

### currentJVMVersion

    static final String currentJVMVersion

Constructor Detail

### CompilerConfiguration

    public CompilerConfiguration()

  Sets the Flags to defaults.

### CompilerConfiguration

    public CompilerConfiguration(CompilerConfiguration configuration)

  Copy constructor. Use this if you have a mostly correct configuration for your compilation but you want to make a some changes programmatically. An important reason to prefer this approach is that your code will most likely be forward compatible with future changes to this configuration API.
  An example of this copy constructor at work:

          // In all likelihood there is already a configuration in your code's context
          // for you to copy, but for the sake of this example we'll use the global default.
          CompilerConfiguration myConfiguration = new CompilerConfiguration(CompilerConfiguration.DEFAULT);
          myConfiguration.setDebug(true);

  param:
    configuration The configuration to copy.

### CompilerConfiguration

    public CompilerConfiguration(Properties configuration)

  Sets the Flags to the specified configuration, with defaults for those not supplied. Note that those "defaults" here do not include checking the settings in System#getProperties() in general, only file.encoding, groovy.target.directory and groovy.source.encoding are.
  If you want to set a few flags but keep Groovy's default configuration behavior then be sure to make your settings in a Properties that is backed by `System.getProperties()` (which is done using this constructor).
  That might be done like this:

          Properties myProperties = new Properties(System.getProperties());
          myProperties.setProperty("groovy.output.debug", "true");
          myConfiguration = new CompilerConfiguration(myProperties);

  And you also have to contend with a possible SecurityException when getting the system properties (See System#getProperties).
  An safer method would be to copy a default CompilerConfiguration and make your changes there using the setter.

          // In all likelihood there is already a configuration for you to copy,
          // but for the sake of this example we'll use the global default.
          CompilerConfiguration myConfiguration = new CompilerConfiguration(CompilerConfiguration.DEFAULT);
          myConfiguration.setDebug(true);

  Another reason to use the copy constructor rather than this one is that you must call #setOutput. Calling `setOutput(null)` is valid and will set up a `PrintWriter` to a bit bucket. The copy constructor will of course set the same one as the original.

  Property Key | Get/Set Property Name
  --- | ---
  `"groovy.warnings"` | #getWarningLevel
  `"groovy.source.encoding"` | #getSourceEncoding
  `"groovy.target.directory"` | #getTargetDirectory
  `"groovy.target.bytecode"` | #getTargetBytecode
  `"groovy.classpath"` | #getClasspath
  `"groovy.output.verbose"` | #getVerbose
  `"groovy.output.debug"` | #getDebug
  `"groovy.errors.tolerance"` | #getTolerance
  `"groovy.script.extension"` | #getDefaultScriptExtension
  `"groovy.script.base"` | #getScriptBaseClass
  `"groovy.recompile"` | #getRecompileGroovySource
  `"groovy.recompile.minimumInterval"` | #getMinimumRecompilationInterval

  param:
    configuration The properties to get flag values from.

Method Detail

### configure

    public void configure(Properties configuration)

  Method to configure a this CompilerConfiguration by using Properties. For a list of available properties look at {link #CompilerConfiguration(Properties).
  param:
    configuration The properties to get flag values from.

### getClasspath

    public List getClasspath()

  return:
    the classpath

### getDebug

    public boolean getDebug()

  Returns true if debugging operation has been requested.

### getDefaultScriptExtension

    public String getDefaultScriptExtension()

### getJointCompilationOptions

    public Map getJointCompilationOptions()

  Gets the joint compilation options for this configuration.
  return:
    the options

### getMinimumRecompilationInterval

    public int getMinimumRecompilationInterval()

### getOutput

    public PrintWriter getOutput()

  Gets the currently configured output writer.

### getPluginFactory

    public ParserPluginFactory getPluginFactory()

### getRecompileGroovySource

    public boolean getRecompileGroovySource()

### getScriptBaseClass

    public String getScriptBaseClass()

  Gets the name of the base class for scripts. It must be a subclass of Script.

### getSourceEncoding

    public String getSourceEncoding()

  Gets the currently configured source file encoding.

### getTargetBytecode

    public String getTargetBytecode()

  Retrieves the compiler bytecode compatibility mode.
  return:
    bytecode compatibility mode. Can be either `1.5` or `1.4`.

### getTargetDirectory

    public File getTargetDirectory()

  Gets the target directory for writing classes.

### getTolerance

    public int getTolerance()

  Returns the requested error tolerance.

### getVerbose

    public boolean getVerbose()

  Returns true if verbose operation has been requested.

### getWarningLevel

    public int getWarningLevel()

  Gets the currently configured warning level. See WarningMessage for level details.

### setClasspath

    public void setClasspath(String classpath)

  Sets the classpath.

### setClasspathList

    public void setClasspathList(List l)

  sets the classpath using a list of Strings
  param:
    l list of strings containg the classpathparts

### setDebug

    public void setDebug(boolean debug)

  Turns debugging operation on or off.

### setDefaultScriptExtension

    public void setDefaultScriptExtension(String defaultScriptExtension)

### setJointCompilationOptions

    public void setJointCompilationOptions(Map options)

  Sets the joint compilation options for this configuration. Using null will disable joint compilation.
  param:
    options the options

### setMinimumRecompilationInterval

    public void setMinimumRecompilationInterval(int time)

### setOutput

    public void setOutput(PrintWriter output)

  Sets the output writer.

### setPluginFactory

    public void setPluginFactory(ParserPluginFactory pluginFactory)

### setRecompileGroovySource

    public void setRecompileGroovySource(boolean recompile)

### setScriptBaseClass

    public void setScriptBaseClass(String scriptBaseClass)

  Sets the name of the base class for scripts. It must be a subclass of Script.

### setSourceEncoding

    public void setSourceEncoding(String encoding)

  Sets the encoding to be used when reading source files.

### setTargetBytecode

    public void setTargetBytecode(String version)

  Allow setting the bytecode compatibility. The parameter can take one of the values `1.5` or `1.4`. If wrong parameter then the value will default to VM determined version.
  param:
    version the bytecode compatibility mode

### setTargetDirectory

    public void setTargetDirectory(String directory)

  Sets the target directory.

### setTargetDirectory

    public void setTargetDirectory(File directory)

  Sets the target directory.

### setTolerance

    public void setTolerance(int tolerance)

  Sets the error tolerance, which is the number of non-fatal errors (per unit) that should be tolerated before compilation is aborted.

### setVerbose

    public void setVerbose(boolean verbose)

  Turns verbose operation on or off.

### setWarningLevel

    public void setWarningLevel(int level)

  Sets the warning level. See WarningMessage for level details.

Copyright © 2003-2009 The Codehaus. All rights reserved.